Bug 1573065

Summary: [Ganesha] File Locking test is failing on ganesha v3 protocol
Product: [Community] GlusterFS Reporter: Jiffin <jthottan>
Component: common-haAssignee: bugs <bugs>
Status: CLOSED NOTABUG QA Contact:
Severity: urgent Docs Contact:
Priority: unspecified    
Version: 3.10CC: bugs, ffilz, jthottan, msaini, rhinduja, rhs-bugs, sheggodu, storage-qa-internal
Target Milestone: ---Keywords: Regression
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: 1565015 Environment:
Last Closed: 2018-04-30 05:28:40 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1565015    
Bug Blocks: 1480138    

Description Jiffin 2018-04-30 05:25:58 UTC
+++ This bug was initially created as a clone of Bug #1565015 +++

Description of problem:

File Locking test is failing on ganesha V3.While verifying BZ-1480138,hit this issue.Even cthon and file locking test is failing with vers=3


Version-Release number of selected component (if applicable):

# rpm -qa | grep ganesha
glusterfs-ganesha-3.12.2-7.el7rhgs.x86_64
nfs-ganesha-gluster-2.5.5-4.el7rhgs.x86_64
nfs-ganesha-2.5.5-4.el7rhgs.x86_64



How reproducible:
3/3

Steps to Reproduce:
1.CReate 4 node ganesha cluster
2.Create 4 x 3 = 12 dist-replicate volume
3.Export the volume via ganesha
4.Run cthon test suit and file locking test

Actual results:

Cthon test is failing-

---------------------------
Test #1 - Test regions of an unlocked file.
	Parent: 1.1  - F_TEST  [               0,               1] PASSED.
	Parent: 1.2  - F_TEST  [               0,          ENDING] PASSED.
	Parent: 1.3  - F_TEST  [               0,7fffffffffffffff] PASSED.
	Parent: 1.4  - F_TEST  [               1,               1] PASSED.
	Parent: 1.5  - F_TEST  [               1,          ENDING] PASSED.
	Parent: 1.6  - F_TEST  [               1,7fffffffffffffff] PASSED.
	Parent: 1.7  - F_TEST  [7fffffffffffffff,               1] PASSED.
	Parent: 1.8  - F_TEST  [7fffffffffffffff,          ENDING] PASSED.
	Parent: 1.9  - F_TEST  [7fffffffffffffff,7fffffffffffffff] PASSED.

Test #2 - Try to lock the whole file.
	Parent: 2.0  - F_TLOCK [               0,          ENDING] FAILED!
	Parent: **** Expected success, returned errno=37...
	Parent: **** Probably implementation error.

** PARENT pass 1 results: 9/9 pass, 0/0 warn, 1/1 fail (pass/total).

**  CHILD pass 1 results: 0/0 pass, 0/0 warn, 0/0 fail (pass/total).
lock tests failed
-------------------------------

File locking test-

--------
# ./a.out /mnt/ganesha_setup2/1G 
opening /mnt/ganesha_setup2/1G
opened; hit Enter to lock... 
locking
fcntl failed (No locks available)

-----------


Expected results:
Locking test should pass with ganesha v3


Additional info:

Messages in ganesha.log-

09/04/2018 01:48:53 : epoch 10430000 : dhcp37-121.lab.eng.blr.redhat.com : ganesha.nfsd-9845[work-214] nsm_monitor :NLM :CRIT :Can not monitor dhcp46-125.lab.eng.blr.redhat.com SM_MON status 1

/var/log/messages-

Apr  9 01:46:02 dhcp37-121 rpc.statd[9837]: Failed to insert: creating /var/lib/nfs/statd/sm/dhcp46-125.lab.eng.blr.redhat.com: Permission denied
Apr  9 01:46:02 dhcp37-121 rpc.statd[9837]: STAT_FAIL to dhcp37-121.lab.eng.blr.redhat.com for SM_MON of dhcp46-125.lab.eng.blr.redhat.com

--- Additional comment from Jiffin on 2018-04-26 04:41:48 EDT ---

RCA : https://bugzilla.redhat.com/show_bug.cgi?id=1414663#c2


The following patch is present in 3.9
https://review.gluster.org/#/c/16433/ which similar issue reported from 1414663.
We need to backport this to 3.4.

Thanks Manisha for digging the old bug and patch